/*{{TIDC_Wizard Auto Code Start                                 */
/****************************************************************/
/* don't change anything here until you know what you are doing!*/
/* the plug-in will change all text between the code marks      */
/* without user interaction!                                    */
/*                                                              */
/****************************************************************/

/****************************************************************/
/* software generated by Data Converter Plug-in (DCP)           */
/* based on <C:\CCSTUD~1.1\PLUGINS\AAP_DEV\c6000\d1605_62.c> */
/****************************************************************/
/****************************************************************/
/* ADS1605 Interface Software Version 2.0 for the TMS320C671x   */
/* Copyright (C) 2004 - 2006 Texas Instruments Incorporated     */
/* All Rights Reserved                                          */
/*--------------------------------------------------------------*/
/** \file
 *  This interface software needs one interrupt to be mapped in
 *  either the DSP/BIOS configuration file or the interrupt
 *  vector table:
 *      EDMA controller interrupt: DCPDISP_dispatchEdmaIsr()
 *
 * This interface software uses two peripherals:
 *   - One EDMA channel (for data transfer)
 *
 * <b>Restrictions:
 *    - It is only possible to submit two buffers at a time. If a
 *      third buffer needs to be submitted, the application has
 *      to wait until the xferInProgress member of the data
 *      converter structure is less than two.
 *      Please note that if the size of the submitted buffers is
 *      too small, there will be a loss of samples between the
 *      two buffers. This is due to the time necessary to link
 *      the transfers together. Therefore, it is recommended to
 *      have a minimum buffer size of 64.
 *    - This version 2.0 is not binary compatible with previous
 *      versions of this software.
 *    - The timings of the external memory interface are
 *      optimized for the TMS320C6713 DSK running at the EMIF
 *      at 100 MHz.If a different H/W platform or a different
 *      EMIF speed is used, the values in the ADS1605_RD_SETUP,
 *      ADS1605_RD_STROBE and ADS1605_RD_HOLD makros below have to
 *      be changed to match the H/W.
 *    - This software requires the buffer to be of type short
 *    - This device needs a reset, followed by a read after
 *      power-up. The routine provided with that interface
 *      software is written for the use with the ADS1605 EVM from
 *      Texas Instruments and toggles the reset pin by writing to
 *      the devices address. If there is different H/W setup
 *      present, the ADS1605_resetDevice() function needs to be
 *      rewritten to mathc this hardware.
 *    - This software works only for the TMS320C671x devices, not
 *      the older TMS320C620x and TMS320C6701 devices. </b>     */
/*--------------------------------------------------------------*/
/* $Revision: 14 $                         $JustDate:  6/30/06 $ */
/* $Author: A0746714 $                                          */
/****************************************************************/
#undef _INLINE

/* Include the interface files for the driver                   */
#include "dc_conf.h"
#include "t1605_fn.h"


/* Include the interface files for the chip support library     */
#include <csl.h>
#include <csl_cache.h>
#include <csl_emif.h>
#include <csl_irq.h>


/* The following settings for the EMIF are optimized for the    */
/* C6713 DSK. If you are using a different H/W, you might want  */
/* change these settings to match your hardware                 */
#define ADS1605_CECTRL_MASK    (0xFFF0C008)
#define CECTRL0                (0x01800008)
#define CECTRL1                (0x01800004)
#define CECTRL2                (0x01800010)
#define CECTRL3                (0x01800014)
#define ADS1605_MTYPE          (2)
#define ADS1605_RD_SETUP       (0)
#define ADS1605_RD_STROBE      (3)
#define ADS1605_RD_HOLD        (0)

/* some other usefull defines                                   */
#define ADS1605_EMIF_SETUP_YES (1)
#define ADS1605_MAX_BLOCKS     (2)
#define ADS1605_MAX_BLOCKSIZE  (0x0000FFFFul)
#define ADS1605_MIN_BLOCKSIZE  (0x00000002ul)

/* This driver does not support the older devices, as they have */
/* a different DMA controller                                   */
#if CHIP6701 | CHIP6201 | CHIP6202 | CHIP6203 | CHIP6204 | CHIP6205
#error Selected DSP is not supported by that software
#endif

/****************************************************************/
/* define and initialize data converter objects                 */
/****************************************************************/
TADS1605 Ads1605_1 = {   /* init object */
    &ADS1605_configure,
    &ADS1605_control,
    &ADS1605_readsample,
    &ADS1605_writesample,
    &ADS1605_readblock,
    &ADS1605_writeblock,
    &ADS1605_close,
    0, 0, 3,            /* 2 reserved + API 3.0  */
    0, 0, 0, 0,         /* buffer object 0       */
    0, 0, 0, 0,         /* buffer object 1       */
    0,                  /* (E)DMA handle         */
    0,                  /* link table pointer    */
    0,                  /* stop table pointer    */
    (volatile short *) ADC1_ADDRESS,
    ADC1_INTPOL,        /* IRQ polarity of DRDY\ */
    0,                  /* LRU buffer object ptr */
    ADC1_INTNUM,        /* IRQ number of DRDY\   */
    ADC1_SETUPEMIF,     /* EMIF setup by driver? */
    0                   /* xfer on progress flag */
};


/****************************************************************/
/* local DSP function prototypes                                */
/****************************************************************/
static TTIDCSTATUS InitEdma(unsigned int *hEdma,
                       unsigned int *hLink,
                       unsigned int *hStop,
                       unsigned int uiIntNumber);
static TTIDCSTATUS InitEmif(volatile short *pAddress);
static TTIDCSTATUS ResetDevice(void *pDC);
static TTIDCSTATUS SubmitBlock(EDMA_Handle hSubmit,
                       unsigned int uiAdsAddress,
                       unsigned int uiBufAddress,
                       unsigned int uiCount,
                       unsigned int uiIntNumber,
                       EDMA_Handle hPrevious,
                       EDMA_Handle hStop);


/****************************************************************/
/* ADS1605_configure()                                          */
/**
 * Operation:     The following operations are performed:
 *     - Configures the EMIF to the correct timings, if this was
 *       requested by the user during configuration.
 *     - Opens the EDMA channel needed for the transfer.
 *       Returns on error.
 *     - Acquires the handles for the EDMA link and stop transfer
 *       tables. Returns on error.
 *     - Registers the EDMA transfer complete code with the EDMA
 *       interrupt dispatcher.
 *     - Calls the reset routine in order to reset the ADS1605
 *       and the FIFO.
 *
 * Parameters:
 *     - void* pDC: Data converter object
 *
 * Return values: Status code of type TTIDCSTATUS
 *     - TIDC_NO_ERR: Call was successful
 *     - TIDC_ERR_NODEVICE: No object was passed to the function
 *     - TIDC_ERR_EDMA: The EDMA channel could not be opened or
 *       one of the link tables could not be allocated.
 *     - TIDC_ERR_XFERPROG: dc_configure was called during an
 *       ongoing transfer
 *     - TIDC_ERR_BADARGS: An invalid argument was passed to the
 *       function
 *
 * Globals modified: In the data converter object:
 *     - hEdmaRead
 *     - hEdmaLinkRead
 *     - hEdmaStop
 *
 * Resources used:
 *     - One EDMA channel
 *     - Two EDMA link tables
*/
/****************************************************************/
TTIDCSTATUS ADS1605_configure(void *pDC)
{
    TADS1605 *pADS = pDC;
    TTIDCSTATUS iStatus;
    unsigned int uiIntNumber;

    /* return, if no device object available                    */
    if (pADS == 0)
        return TIDC_ERR_NODEVICE;

    /* be sure no block transfer is in progress                 */
    if (pADS->xferInProgress !=0)
        return TIDC_ERR_XFERPROG;

    uiIntNumber = pADS->uiDrdyIntNum;

    /* configure the EMIF if selected by the customer           */
    if (pADS->emifSetup == ADS1605_EMIF_SETUP_YES)
        (void)InitEmif(pADS->adcReadAdr);

    /* open the EDMA channel for the data transfer              */
    iStatus = InitEdma(&pADS->hEdmaRead,
                       &pADS->hEdmaLinkRead,
                       &pADS->hEdmaStop,
                       uiIntNumber);
    if (iStatus != TIDC_NO_ERR)
    {
        (void)ADS1605_close(pADS);
        return iStatus;
    }

    /* register the EDMA transfer complete code with the EDMA   */
    /* interrupt dispatcher                                     */
    iStatus = DCPDISP_registerIsr((void*)pADS,
                                 ADS1605_rblock_finished,
                                 uiIntNumber);
    if (iStatus != TIDC_NO_ERR)
    {
        (void)ADS1605_close(pADS);
        return iStatus;
    }

    /* call the reset routine for the device                    */
    iStatus = ResetDevice(pADS);
    if (iStatus != TIDC_NO_ERR)
    {
        (void)ADS1605_close(pADS);
        return iStatus;
    }

    return TIDC_NO_ERR;
}


/****************************************************************/
/* ADS1605_control()                                            */
/** Operation:
 *     - Translates the command macros to the proper commands for
 *       the ADS1605.
 * Parameters:
 *     - void* pDC: Data converter object
 *     - int iCmd:  Action to be performed. Valid are:
 *           - ADS1605_CMD_RESET:
 *                 Resets the converter by calling the ResetDevice
 *                 routine. No additional parameter is needed.
 *     - void *pValue: Additional parameters for the command.
 *
 * Return value:
 *     - TIDC_NO_ERR: No problem occurred.
 *     - TIDC_ERR_BADARGS: An invalid command was submitted
 *     - TIDC_ERR_NODEVICE: No object was passed to the function.
 *
 * Globals modified:None
 *
 * Resources used:  None
 */
/****************************************************************/
TTIDCSTATUS ADS1605_control(void *pDC, int iCmd, void *pValue)
{
    TADS1605 *pADS = pDC;
    int iStatus;

    if (iCmd == ADS1605_CMD_RESET)
    {
        iStatus = ResetDevice(pADS);
        if (iStatus != TIDC_NO_ERR)
            return iStatus;
    }
    else
        return TIDC_ERR_BADARGS;

    return TIDC_NO_ERR;
}


/****************************************************************/
/* ADS1605_readsample()                                         */
/**Operation:
 *     - Reads a single 16 bit word from the ADS1605
 *     - This routine blindly reads a word from the data converter
 *       without taking care of the FIFO lever or of the
 *       interrupt and is therefore not suitable for continuous
 *       conversion.
 *
 * Parameters:
 *     - void *pDC: Data converter object
 *     - long *lData: Memory location used to return the
 *       conversion result (out-parameter).
 *
 * Return value:  Status code of type TTIDCSTATUS
 *     - TIDC_NO_ERR: Call was successfull.
 *     - TIDC_ERR_NODEVICE: No object was passed to the function.
 *     - TIDC_ERR_XFERPROG: A block transfer is in progress, so
 *       this function cannot be executed.
 *
 * Globals modified:
 *     - None
 *
 * Resources used:
 *     - None
 */
/****************************************************************/
TTIDCSTATUS ADS1605_readsample(void *pDC, long * lData)
{
    TADS1605 *pADS = pDC;

    /* return, if no device object available                    */
    if (pADS == 0)
        return TIDC_ERR_NODEVICE;

    /* return, if a block transfer is ongoing                   */
    if (pADS->xferInProgress !=0)
        return TIDC_ERR_XFERPROG;

    *lData = (long)(*(pADS->adcReadAdr));

    return TIDC_NO_ERR;
}


/****************************************************************/
/* ADS1605_readblock()                                          */
/**Operation:
 *     - Initializes the transfer of a block of data from the
 *       ADS1605. Once the transfer is started, the function
 *       returns to the application level.
 *     - It uses one EDMA channel for the data transfer.
 *     - The EDMA channel for the collection of the data samples
 *       is synchronized to the DRDY signal.
 *     - Once the transfer is complete, the ADS1605_rblock_finished
 *       routine will be called, which then signals the end of the
 *       transfer to the application level by the means of a
 *       callback function.
 *
 * Parameters:
 *     - void *pD:CData converter object
 *     - void *pData: Pointer to the data block
 *     - unsigned long ulCount: Number of samples to be read
 *     - void *readCallback: Pointer to callback function
 *
 * Return value:
 *     - None
 *
 * Globals modified:
 *     - Inside the data converter object:
 *         - iObjectIndex
 *         - xferInProgress
 *     - Inside the xferBuffer object:
 *         - sbufPtr
 *         - uibufSize
 *         - uiStatus
 *         - ptrCallback
 *
 * Resources used:
 *     - One EDMA channel (opened by ADS1605_configure())
 *
 * Remarks:
 *     - Only one buffer can be active at one time while a
 *       second buffer can be submitted.
 *     - No single word transfer is allowed. The ADS1605_readsample()
 *       routine should be used instead.
 *     - The number of samples to be transfered cannot exceed
 *       0xffff.
 */
/****************************************************************/
TTIDCSTATUS ADS1605_readblock(void *pDC,
                              void *pData,
                              unsigned long ulCount,
                              void (*readCallback) (void *))
{
    TADS1605 *pADS = pDC;
    unsigned int uiIntNumber;

    /* no single word transfer is allowed.Also return if the    */
    /* maximum number of transfers was already submitted        */
    if(pADS == 0)
        return TIDC_ERR_NODEVICE;
    if ((ulCount > ADS1605_MAX_BLOCKSIZE)
        || (ulCount < ADS1605_MIN_BLOCKSIZE))
        return TIDC_ERR_BADARGS;

    if (pADS->xferInProgress == ADS1605_MAX_BLOCKS)
        return TIDC_ERR_XFERPROG;
    else
        pADS->xferInProgress += 1;

    /* select the next free buffer object                       */
    if (pADS->xferBuffer[0].uiStatus == ADS1605_BUFOBJECT_FREE)
        pADS->iObjectIndex = 0; /* object 0 is free             */
    else
        pADS->iObjectIndex = 1; /* object 1 is free             */

    pADS->xferBuffer[pADS->iObjectIndex].ptrCallBack = readCallback;
    pADS->xferBuffer[pADS->iObjectIndex].sBufPtr = (short *)pData;
    pADS->xferBuffer[pADS->iObjectIndex].uiBufSize = (unsigned int)ulCount;
    pADS->xferBuffer[pADS->iObjectIndex].uiStatus = ADS1605_BUFOBJECT_INUSE;

    /* make sure the cache is coherent                          */
    CACHE_wbInvL1d((void *)pData,
                   2 * (unsigned int)ulCount,
                   CACHE_WAIT);

    uiIntNumber = pADS->uiDrdyIntNum;

    /* there is no transfer running and no transfer pending     */
    if (pADS->xferInProgress == 1)
    {
        /* submit the block for the data transfer               */
        (void)SubmitBlock(pADS->hEdmaRead,
               (unsigned int)pADS->adcReadAdr,
               (unsigned int)pADS->xferBuffer[pADS->iObjectIndex].sBufPtr,
               pADS->xferBuffer[pADS->iObjectIndex].uiBufSize,
               uiIntNumber,
               (EDMA_Handle)0,
               pADS->hEdmaStop);

        /* start the EDMA channel                               */
        EDMA_clearChannel(pADS->hEdmaRead);
        EDMA_intClear(uiIntNumber);
        EDMA_intEnable(uiIntNumber);
        EDMA_enableChannel(pADS->hEdmaRead);

        IRQ_enable(IRQ_EVT_EDMAINT);    /* enable the EDMA interrupt*/
    }

    if (pADS->xferInProgress == 2)
        /* queue the block for the data transfer                */
        (void)SubmitBlock(pADS->hEdmaLinkRead,
               (unsigned int)pADS->adcReadAdr,
               (unsigned int)pADS->xferBuffer[pADS->iObjectIndex].sBufPtr,
               pADS->xferBuffer[pADS->iObjectIndex].uiBufSize,
               uiIntNumber,
               pADS->hEdmaRead,
               pADS->hEdmaStop);

    /* return to the calling routine                            */
    return TIDC_NO_ERR;
}


/****************************************************************/
/* ADS1605_writesample()                                        */
/**Operation:
 *     Not implemented. This function just returns.
 *
 * Parameters:
 *     - void* pDC: Data converter object
 *     - long lData: Data to be written to the converter
 *
 * Return value:  Status code of type TTIDCSTATUS
 *     - TIDC_ERR_FXNNULL: This function is not implemented
 *
 * Globals modified:
 *     - None
 *
 * Resources used:
 *     - None
 */
/****************************************************************/
TTIDCSTATUS ADS1605_writesample(void *pDC, long lData)
{
    return TIDC_ERR_FXNNULL;
}


/****************************************************************/
/* ADS1605_writeblock()                                         */
/**Operation:
 *     - Not implemented. This function just returns.
 *
 * Parameters:
 *     - void* pDC: Data converter object
 *     - void* lData: Pointer to the block of data to be written
 *     - unsigned long ulCount: Number of words
 *     - void (*callback): Pointer to the callback function
 *
 * Return value:  Status code of type TTIDCSTATUS
 *     - TIDC_ERR_FXNNULL: This function is not implemented
 *
 * Globals modified:
 *     - None
 *
 * Resources used:
 *     - None
 */
/****************************************************************/
TTIDCSTATUS ADS1605_writeblock(void *pDC, void *pData,
                               unsigned long ulCount,
                               void (*callback) (void *))
{
    return TIDC_ERR_FXNNULL;
}


/****************************************************************/
/* ADS1605_close()                                              */
/**Operation:
 *     - Closes all the resources used on the DSP.
 *     - Unregisters the interrupt service routine with the EDMA
 *       interrupt dispatcher
 *
 * Parameters:
 *     - void* pDC: Data converter object
 *
 * Return value:  Status code of type TTIDCSTATUS
 *     - TIDC_NO_ERR: No problem occurred
 *
 * Globals modified: The following items are modified inside
 *     data converter object:
 *     - hEdmaRead
 *     - hEdmaLinkRead
 *     - hEdmaStop
 *     - xferInProgress
 *     - iObjectIndex
 *
 * Resources used:
 *     - One EDMA channel (closed)
 *     - Two EDMA link tables (freed)
 */
/****************************************************************/
TTIDCSTATUS ADS1605_close(void *pDC)
{
    TADS1605 *pADS = pDC;
    unsigned int uiIntNumber;

    /* return, if no device object available                    */
    if (pADS == 0)
        return TIDC_ERR_NODEVICE;

    uiIntNumber = pADS->uiDrdyIntNum;

    /* close the EDMA channel, if they have been opened         */
    if ((pADS->hEdmaRead != 0) && (pADS->hEdmaRead != EDMA_HINV))
    {
        EDMA_intDisable(uiIntNumber);
        EDMA_disableChannel(pADS->hEdmaRead);
        EDMA_close(pADS->hEdmaRead);
        pADS->hEdmaRead = 0;
    }

    /* free the tables associated with the transfer             */
    if ((pADS->hEdmaLinkRead != 0)
        && (pADS->hEdmaLinkRead != EDMA_HINV))
    {
        EDMA_freeTable(pADS->hEdmaLinkRead);
        pADS->hEdmaLinkRead = 0;
    }
    if ((pADS->hEdmaStop != 0) && (pADS->hEdmaStop != EDMA_HINV))
    {
        EDMA_freeTable(pADS->hEdmaStop);
        pADS->hEdmaStop = 0;
    }

    /* unregister the EDMA transfer complete code with the      */
    /* EDMA interrupt dispatcher                                */
    (void)DCPDISP_unregisterIsr(uiIntNumber);

    /* reset the transfer in progress semaphore                 */
    pADS->xferInProgress = 0;
    pADS->iObjectIndex = 0;
    pADS->xferBuffer[0].uiStatus = ADS1605_BUFOBJECT_FREE;
    pADS->xferBuffer[1].uiStatus = ADS1605_BUFOBJECT_FREE;

    return TIDC_NO_ERR;
}


/****************************************************************/
/* ADS1605_rblock finished()                                    */
/**Operation:
 *     - This function was registered with the DCP EDMA interrupt
 *       dispatcher by the ADS1605_configure() function.
 *     - Cleans up the cache.
 *     - Disables the EDMA channel if the last transfer in a
 *       queue finished.
 *     - If requested, a user-defined callback function will be
 *       called at the end.
 *
 * Parameters:
 *    - void *pDC: Data converter object. Will be provided by
 *      the DCP EDMA interrupt dispatcher
 *
 * Return value (of type TTIDCSTATUS):
 *     - TIDC_ERR_NODEVICE: The passed data converter object is
 *       not valid
 *     - TIDC_NO_ERR: Everything is fine
 *
 * Globals modified: In the data converter object:
 *     - xferInPorgress
 *     - uiStatus inside the transfer buffer object
 *
 * Resources used:  None
 */
/****************************************************************/
TTIDCSTATUS ADS1605_rblock_finished(void *pDC)
{
    TADS1605 *pADS = pDC;
    int iIndex;

    if (pADS == 0)
        return TIDC_ERR_NODEVICE;

    if (pADS->xferInProgress == 2)
        iIndex = (pADS->iObjectIndex + 1) & 0x0001;
    else
    {
        iIndex = pADS->iObjectIndex;
        EDMA_disableChannel(pADS->hEdmaRead);
    }
    if (pADS->xferBuffer[iIndex].ptrCallBack)
    {
        pADS->xferBuffer[iIndex].uiStatus = ADS1605_BUFOBJECT_COMPLETE;
        pADS->xferBuffer[iIndex].ptrCallBack(pADS);
    }
    pADS->xferBuffer[iIndex].uiStatus = ADS1605_BUFOBJECT_FREE;

   /* signal that the transfer was successful                   */
   pADS->xferInProgress -= 1;         /* clear flag             */

   return TIDC_NO_ERR;
}


/****************************************************************/
/* InitEdma():                                                  */
/** Operation:
 *    - Opens the EDMA channel assiciated with the DRDY interrupt
 *    - Allocates a parameter table for the EDMA link table and
 *      initializes the associated handle
 *    - Allocates a parameter table for the EDMA stop table and
 *      initializes the associated handle
 *    - Initializes the EDMA parameter table for the stop
 *      transfer to zero.
 *
 * Parameters:
 *     - unsigned int *hEdma: Pointer to the handle of the EDMA
 *       channel for the transfer
 *     - unsigned int *hLink: Pointer to the handle of the
 *       link transfer table
 *     - unsigned int *hStop: Pointer to the handel of the
 *       stop transfer table
 *     - unsigned int uiIntNumber: The interrupt number used
 *       to synchronize the transfer.
 *
 * Return value (of type TTIDCSTATUS):
 *     - TIDC_NO_ERR in case everything was OK
 *     - TIDC_ERR_EDMA if the EDMA channel could not be opened,
 *       or if one of the tables could not be allocated
 *
 * Globals modified: In the data converter object:
 *    - hEdma
 *    - hEdmaLink
 *    - hEdmaStop
 *
 * Resources used:
 *    - One EDMA channel
 *    - Two EDMA parameter RAM tables
 */
/****************************************************************/
static TTIDCSTATUS InitEdma(unsigned int *hEdma,
                    unsigned int *hLink, unsigned int *hStop,
                    unsigned int uiIntNumber)
{
    /* if the channel is not open yet, open it                  */
    if ((*hEdma == EDMA_HINV) || (*hEdma == 0))
    {
        *hEdma = EDMA_open((int)uiIntNumber, EDMA_OPEN_RESET);
        if (*hEdma == EDMA_HINV)
            return TIDC_ERR_EDMA;
    }

    /* get table entries for the link and the stop transfer and */
    /* check if the tables are valid                            */
    *hLink = EDMA_allocTable(-1);
    if (*hLink == EDMA_HINV)
        return TIDC_ERR_EDMA;

    if ((*hStop == 0) || (*hStop == EDMA_HINV))
    {
        *hStop = EDMA_allocTable(-1);
        if (*hStop == EDMA_HINV)
            return TIDC_ERR_EDMA;

        /* the stop transfer table contains only zeros, so it   */
        /* could be initialized now                             */
        EDMA_configArgs(*hStop, 0, 0, 0, 0, 0, 0);
    }

    EDMA_intClear(uiIntNumber);

    return TIDC_NO_ERR;
}


/****************************************************************/
/* InitEmif()                                                   */
/**Operation:
 *     - Sets up the EMIF to the correct timings for the ADS1605
 *
 * Parameters:
 *     - volatile short *pAddress: Address of the ADS1605
 *
 * Return value: Of type TTIDCSTATUS:
 *     - TIDC_NO_ERR: Everything was OK
 *
 * Globals modified:
 *     - None
 *
 * Resources used:
 *     - None
 */
/****************************************************************/
static TTIDCSTATUS InitEmif(volatile short *pAddress)
{
    volatile unsigned int *pCeCtrl;
    unsigned int uiCeValue;
    unsigned int uiCeSpace;

    uiCeValue = (unsigned int)(ADS1605_RD_HOLD
                | (ADS1605_MTYPE << 4)
                | (ADS1605_RD_STROBE << 8)
                | (ADS1605_RD_SETUP << 16));

    uiCeSpace = (((unsigned int)pAddress >> 28) & 0x00000007);

    /* det the variable for the CECNTR to the correct value     */
    switch (uiCeSpace)
    {
        case 0: pCeCtrl = (volatile unsigned int *) CECTRL0;
                break;
        case 1: pCeCtrl = (volatile unsigned int *) CECTRL1;
                break;
        case 2: pCeCtrl = (volatile unsigned int *) CECTRL2;
                break;
        case 3: pCeCtrl = (volatile unsigned int *) CECTRL3;
                break;
    }

    *pCeCtrl = (*pCeCtrl & ADS1605_CECTRL_MASK) | uiCeValue;

    return TIDC_NO_ERR;
}


/****************************************************************/
/* ResetDevice()                                                */
/**Operation:
 *    - Issues a reset command to the device by toggling the
 *      reset pin.
 *    - Please note that this routine is written for the use
 *      with the ADS1605 EVM. In case of another H/W connection,
 *      this routine needs to be modified to match the actual H/W.
 *
 * Parameters:
 *    - void *pDc: Data converter object
 *
 * Return values: Status code of type TTIDCSTATUS
 *    - TTIDC_NO_ERR: No error occurred
 *
 * Globals modified:
 *    - None
 *
 * Resources used:
 *    - None
 */
/****************************************************************/
static TTIDCSTATUS ResetDevice(void *pDC)
{
    TADS1605 *pADS = pDC;
    unsigned short uiDrdyPeriods = 0;

    if (pADS == 0)
        return TIDC_ERR_NODEVICE;

    /* this write issues the reset to the ADS1605 on the EVM.   */
    /* If there is a different H/W present, this line needs to  */
    /* be replaced by the code needed to reset the device.      */
    *pADS->adcReadAdr = 0;

    /* once the device and the FIFO is reset, it is necessary   */
    /* to wait for the correct number of DRDY cycles until the  */
    /* digital filter is fully settled. This is achieved by     */
    /* counting the number of DRDY periods while skipping read  */
    /* WARNING: THIS TAKES 9.4usec AND IS A BLOCKING FUNCTION   */
    IRQ_clear(pADS->uiDrdyIntNum);
    do
    {
        while (IRQ_test(pADS->uiDrdyIntNum) != 1);
        IRQ_clear(pADS->uiDrdyIntNum);
        uiDrdyPeriods++;
    } while (uiDrdyPeriods < 4);

    return TIDC_NO_ERR;
}


/****************************************************************/
/* SubmitBlock()                                                */
/**Operation: The following operations are performed depending
 *     on of there is already a transfer running or not.
 *     - If this is the first transfer, it initalizes the EDMA
 *       channel registers.
 *     - If this is the second transfer, it initializes the
 *       link table and links the first transfer to the pending
 *       one
 *     - If there was an ongoing transfer, the function tests if
 *       this transfer expired in the meantime. If yes, it does
 *       not link the new transfer, but configures the EDMA
 *       controller directly.
 *
 * Parameters:
 *     - EDMA_Handle hSubmit: This is either the handle to the
 *       EDMA channel or the handle to the link table.
 *     - unsigned int uiSrcAddress: Where to read from (ADS8481
 *       address)
 *     - unsigned int uiDstAddress: Address of the buffer to be
 *       filled
 *     - unsigned int uiCount: Number of elements to transfer
 *     - unsigned int uiIntNumber: Number of the interrupt used to
 *       synchronize the transfer.
 *     - EDMA_Handle hPrevious: Is zero, if this is the first
 *       submitted transfer, contains the pointer to the EDMA
 *       handle, if this is the second submitted buffer.
 *       This parameter will be used for linking the two
 *       transfers together.
 *     - EDMA_Handle hStop: Handle for the stop transfer
 *
 * Return value (of type TTIDCSTATUS):
 *     - TIDC_NO_ERR: No error occurred
 *
 * Globals modified: in DC object:
 *     - None
 *
 * Resources used:
 *     - None
 */
/****************************************************************/
static TTIDCSTATUS SubmitBlock(EDMA_Handle hSubmit,
                               unsigned int uiAdsAddress,
                               unsigned int uiBufAddress,
                               unsigned int uiCount,
                               unsigned int uiIntNumber,
                               EDMA_Handle hPrevious,
                               EDMA_Handle hStop)
{
    /* if there was a previous transfer, look it it has         */
    /* finished in the meantime. if yes, don't link, but program*/
    /* the EDMA channel directly.                               */
    if (hPrevious != 0)
    {
        if (EDMA_RGETH(hPrevious, SRC) == 0)
        {
            EDMA_disableChannel(hPrevious);
            EDMA_RSETH(hPrevious, SRC, uiAdsAddress);
            EDMA_RSETH(hPrevious, DST, uiBufAddress);
            EDMA_RSETH(hPrevious, OPT, ADS1605_EDMAOPT_INPUT_VALUE | (uiIntNumber << 16));
            EDMA_RSETH(hPrevious, CNT, uiCount);
            EDMA_RSETH(hPrevious, IDX, 0);
            EDMA_RSETH(hPrevious,RLD,EDMA_getTableAddress(hStop) & 0x0000FFFFu);
            EDMA_clearChannel(hPrevious);
            EDMA_enableChannel(hPrevious);
            return TIDC_NO_ERR;
        }
    }

    EDMA_RSETH(hSubmit, SRC, uiAdsAddress);
    EDMA_RSETH(hSubmit, DST, uiBufAddress);
    EDMA_RSETH(hSubmit, OPT, ADS1605_EDMAOPT_INPUT_VALUE | (uiIntNumber << 16));
    EDMA_RSETH(hSubmit, CNT, uiCount);
    EDMA_RSETH(hSubmit, IDX, 0);
    EDMA_RSETH(hSubmit,RLD,EDMA_getTableAddress(hStop) & 0x0000FFFFu);

    if (hPrevious != 0)
        EDMA_link(hPrevious, hSubmit);

    return TIDC_NO_ERR;
}

/****************************************************************/
/* END OF t1605_ob.c                                             */
/****************************************************************/
/*TIDC_Wizard Auto Code End}}*/
